diff -uwr sourceold/scripts/jfwsnd.cpp source/scripts/jfwsnd.cpp
--- sourceold/scripts/jfwsnd.cpp	2012-02-13 19:12:33.200593700 +0800
+++ source/scripts/jfwsnd.cpp	2012-05-28 09:47:05.897078200 +0800
@@ -218,7 +218,7 @@
 
 void JFW_2D_Sound_Damage_Range::Damaged(GameObject *obj,GameObject *damager,float amount)
 {
-	if ((Commands->Get_Health(obj) <= Get_Float_Parameter("MaxHealth")) && (Commands->Get_Health(obj) <= Get_Float_Parameter("MinHealth")))
+	if ((Commands->Get_Health(obj) <= Get_Float_Parameter("MaxHealth")) && (Commands->Get_Health(obj) >= Get_Float_Parameter("MinHealth")))
 	{
 		if (enabled)
 		{
@@ -237,6 +237,76 @@
 	Auto_Save_Variable(&enabled,1,1);
 }
 
+void JFW_2D_Sound_Damage_Range_Team::Created(GameObject *obj)
+{
+	enabled = true;
+}
+
+void JFW_2D_Sound_Damage_Range_Team::Damaged(GameObject *obj,GameObject *damager,float amount)
+{
+	if ((Commands->Get_Health(obj) <= Get_Float_Parameter("MaxHealth")) && (Commands->Get_Health(obj) >= Get_Float_Parameter("MinHealth")))
+	{
+		if (enabled)
+		{
+			enabled = false;
+			Create_2D_Sound_Team(Get_Parameter("Sound"),Get_Object_Type(obj));
+		}
+	}
+	else
+	{
+		enabled = true;
+	}
+}
+
+void JFW_2D_Sound_Damage_Range_Team_String::Register_Auto_Save_Variables()
+{
+	Auto_Save_Variable(&enabled,1,1);
+}
+
+void JFW_2D_Sound_Damage_Range_Team_String::Created(GameObject *obj)
+{
+	enabled = true;
+}
+
+extern REF_DECL2(NodHouseColor, Vector3);
+extern REF_DECL2(GDIHouseColor, Vector3);
+void JFW_2D_Sound_Damage_Range_Team_String::Damaged(GameObject *obj,GameObject *damager,float amount)
+{
+	if ((Commands->Get_Health(obj) <= Get_Float_Parameter("MaxHealth")) && (Commands->Get_Health(obj) >= Get_Float_Parameter("MinHealth")))
+	{
+		if (enabled)
+		{
+			enabled = false;
+			Create_2D_Sound_Team(Get_Parameter("Sound"),Get_Object_Type(obj));
+			int red = 0;
+			int blue = 0;
+			int green = 0;
+			if (Get_Object_Type(obj) == 0)
+			{
+				red = (int)(NodHouseColor.X * 255);
+				green = (int)(NodHouseColor.Y * 255);
+				blue = (int)(NodHouseColor.Z * 255);
+			}
+			else
+			{
+				red = (int)(GDIHouseColor.X * 255);
+				green = (int)(GDIHouseColor.Y * 255);
+				blue = (int)(GDIHouseColor.Z * 255);
+			}
+			Send_Message_Team(Get_Object_Type(obj),red,green,blue,Get_Parameter("String"));
+		}
+	}
+	else
+	{
+		enabled = true;
+	}
+}
+
+void JFW_2D_Sound_Damage_Range_Team::Register_Auto_Save_Variables()
+{
+	Auto_Save_Variable(&enabled,1,1);
+}
+
 void JFW_3D_Sound_Damage_Range::Created(GameObject *obj)
 {
 	enabled = true;
@@ -430,7 +500,7 @@
 	c = Get_Parameter("Sound");
 	if (number == timernumber)
 	{
-		if (Is_Vehicle(obj))
+		if (obj->As_VehicleGameObj())
 		{
 			if (Get_Vehicle_Occupant_Count(obj) >= Get_Vehicle_Seat_Count(obj))
 			{
@@ -514,6 +584,8 @@
 ScriptRegistrant<JFW_Fade_Background_Music_On_Enter> JFW_Fade_Background_Music_On_Enter_Registrant("JFW_Fade_Background_Music_On_Enter","Music:string,unk1:int,unk2:int");
 ScriptRegistrant<JFW_Stop_Background_Music_On_Enter> JFW_Stop_Background_Music_On_Enter_Registrant("JFW_Stop_Background_Music_On_Enter","");
 ScriptRegistrant<JFW_2D_Sound_Damage_Range> JFW_2D_Sound_Damage_Range_Registrant("JFW_2D_Sound_Damage_Range","Sound:string,MinHealth:float,MaxHealth:float");
+ScriptRegistrant<JFW_2D_Sound_Damage_Range_Team> JFW_2D_Sound_Damage_Range_Team_Registrant("JFW_2D_Sound_Damage_Range_Team","Sound:string,MinHealth:float,MaxHealth:float");
+ScriptRegistrant<JFW_2D_Sound_Damage_Range_Team_String> JFW_2D_Sound_Damage_Range_Team_String_Registrant("JFW_2D_Sound_Damage_Range_Team_String","Sound:string,MinHealth:float,MaxHealth:float,String:string");
 ScriptRegistrant<JFW_3D_Sound_Damage_Range> JFW_3D_Sound_Damage_Range_Registrant("JFW_3D_Sound_Damage_Range","Sound:string,MinHealth:float,MaxHealth:float,Offset:vector3");
 ScriptRegistrant<JFW_3D_Sound_Timer> JFW_3D_Sound_Timer_Registrant("JFW_3D_Sound_Timer","Time:float,TimerNum:int,Repeat:int,Sound:string,Offset:vector3");
 ScriptRegistrant<JFW_2D_Sound_Damage> JFW_2D_Sound_Damage_Registrant("JFW_2D_Sound_Damage","Sound:string,Health:float");
diff -uwr sourceold/scripts/jfwsnd.h source/scripts/jfwsnd.h
--- sourceold/scripts/jfwsnd.h	2011-10-14 22:27:31.957031200 +0800
+++ source/scripts/jfwsnd.h	2012-05-28 09:47:05.779890700 +0800
@@ -51,6 +51,20 @@
 	public: void Register_Auto_Save_Variables();
 };
 
+class JFW_2D_Sound_Damage_Range_Team : public ScriptImpClass {
+	bool enabled;
+	void Created(GameObject *obj);
+	void Damaged(GameObject *obj,GameObject *damager,float amount);
+	public: void Register_Auto_Save_Variables();
+};
+
+class JFW_2D_Sound_Damage_Range_Team_String : public ScriptImpClass {
+	bool enabled;
+	void Created(GameObject *obj);
+	void Damaged(GameObject *obj,GameObject *damager,float amount);
+	public: void Register_Auto_Save_Variables();
+};
+
 class JFW_3D_Sound_Damage_Range : public ScriptImpClass {
 	bool enabled;
 	void Created(GameObject *obj);
diff -uwr sourceold/scripts/jfwveh.cpp source/scripts/jfwveh.cpp
--- sourceold/scripts/jfwveh.cpp	2012-02-23 12:06:21.760742100 +0800
+++ source/scripts/jfwveh.cpp	2012-04-24 21:25:31.486328100 +0800
@@ -902,7 +902,7 @@
 		if (!active)
 		{
 			GameObject *vobj = 0;
-			if (Is_Vehicle(enterer))
+			if (enterer->As_VehicleGameObj())
 			{
 				vobj = enterer;
 			}
@@ -929,17 +929,22 @@
 	Vector3 pos2;
 	float distance;
 	GameObject *object = Commands->Find_Object(number);
+	if (!object)
+	{
+		return;
+	}
 	pos1 = Commands->Get_Position(obj);
 	pos2 = Commands->Get_Position(object);
 	distance = Commands->Get_Distance(pos1,pos2);
 	if (distance <= 10.0)
 	{
-		if (Is_Vehicle(object))
+		if (object->As_VehicleGameObj())
 		{
 			if (Get_Vehicle_Mode(object) == VEHICLE_TYPE_FLYING && Get_Vehicle_Driver(object))
 			{
 				Commands->Give_PowerUp(object,Get_Parameter("Reload_Powerup"),false);
 				Commands->Start_Timer(obj, this, Get_Float_Parameter("Reload_Interval"), number);
+				active = true;
 			}
 		}
 	}
diff -uwr sourceold/scripts/jfwzone.cpp source/scripts/jfwzone.cpp
--- sourceold/scripts/jfwzone.cpp	2012-02-23 12:11:58.802734300 +0800
+++ source/scripts/jfwzone.cpp	2012-05-28 09:47:05.711531300 +0800
@@ -23,6 +23,7 @@
 #include "BuildingGameObjDef.h"
 #include "dp88_custom_timer_defines.h"
 #include "PhysicalGameObj.h"
+#include "VehicleGameObj.h"
 
 void JFW_3D_Sound_Zone::Entered(GameObject *obj,GameObject *enterer)
 {
@@ -379,7 +380,7 @@
 	{
 		return;
 	}
-	if (Is_Vehicle(enterer))
+	if (enterer->As_VehicleGameObj())
 	{
 		Commands->Start_Timer(obj,this,1.0,Commands->Get_ID(enterer));
 	}
@@ -399,13 +400,20 @@
 		float Health = Commands->Get_Health(Commands->Find_Object(number));
 		float Max_Shield_Strength = Commands->Get_Max_Shield_Strength(Commands->Find_Object(number));
 		float Shield_Strength = Commands->Get_Shield_Strength(Commands->Find_Object(number));
+		bool repair = false;
 		if (Health < Max_Health)
 		{
 			Commands->Set_Health(Commands->Find_Object(number),Health + Get_Float_Parameter("Repair_Health"));
+			repair = true;
 		}
 		if (Shield_Strength < Max_Shield_Strength)
 		{
 			Commands->Set_Shield_Strength(Commands->Find_Object(number),Shield_Strength + Get_Float_Parameter("Repair_Health"));
+			repair = true;
+		}
+		if (repair && Commands->Find_Object(number)->As_VehicleGameObj())
+		{
+			Commands->Find_Object(number)->As_VehicleGameObj()->Damage_Meshes_Update(); //repair was done, update damage meshes
 		}
 		Commands->Start_Timer(obj,this,1.0,number);
 	}
@@ -420,7 +428,7 @@
 	}
 	if ((!_stricmp(Commands->Get_Preset_Name(enterer),Get_Parameter("Preset1"))) || (!_stricmp(Commands->Get_Preset_Name(enterer),Get_Parameter("Preset2"))) || (!_stricmp(Commands->Get_Preset_Name(enterer),Get_Parameter("Preset3"))) || (!_stricmp(Commands->Get_Preset_Name(enterer),Get_Parameter("Preset4"))) || (!_stricmp(Commands->Get_Preset_Name(enterer),Get_Parameter("Preset5"))) || (!_stricmp(Commands->Get_Preset_Name(enterer),Get_Parameter("Preset6"))) || (!_stricmp(Commands->Get_Preset_Name(enterer),Get_Parameter("Preset7"))) || (!_stricmp(Commands->Get_Preset_Name(enterer),Get_Parameter("Preset8"))))
 	{
-		if (Is_Vehicle(enterer))
+		if (enterer->As_VehicleGameObj())
 		{
 			Commands->Start_Timer(obj,this,1.0,Commands->Get_ID(enterer));
 		}
@@ -441,13 +449,20 @@
 		float Health = Commands->Get_Health(Commands->Find_Object(number));
 		float Max_Shield_Strength = Commands->Get_Max_Shield_Strength(Commands->Find_Object(number));
 		float Shield_Strength = Commands->Get_Shield_Strength(Commands->Find_Object(number));
+		bool repair = false;
 		if (Health < Max_Health)
 		{
 			Commands->Set_Health(Commands->Find_Object(number),Health + Get_Float_Parameter("Repair_Health"));
+			repair = true;
 		}
 		if (Shield_Strength < Max_Shield_Strength)
 		{
 			Commands->Set_Shield_Strength(Commands->Find_Object(number),Shield_Strength + Get_Float_Parameter("Repair_Health"));
+			repair = true;
+		}
+		if (repair && Commands->Find_Object(number)->As_VehicleGameObj())
+		{
+			Commands->Find_Object(number)->As_VehicleGameObj()->Damage_Meshes_Update(); //repair was done, update damage meshes
 		}
 		Commands->Start_Timer(obj,this,1.0,number);
 	}
@@ -462,7 +477,7 @@
 	}
 	if ((_stricmp(Commands->Get_Preset_Name(enterer),Get_Parameter("Preset1"))) && (_stricmp(Commands->Get_Preset_Name(enterer),Get_Parameter("Preset2"))) && (_stricmp(Commands->Get_Preset_Name(enterer),Get_Parameter("Preset3"))) && (_stricmp(Commands->Get_Preset_Name(enterer),Get_Parameter("Preset4"))) && (_stricmp(Commands->Get_Preset_Name(enterer),Get_Parameter("Preset5"))) && (_stricmp(Commands->Get_Preset_Name(enterer),Get_Parameter("Preset6"))) && (_stricmp(Commands->Get_Preset_Name(enterer),Get_Parameter("Preset7"))) && (_stricmp(Commands->Get_Preset_Name(enterer),Get_Parameter("Preset8"))))
 	{
-		if (Is_Vehicle(enterer))
+		if (enterer->As_VehicleGameObj())
 		{
 			Commands->Start_Timer(obj,this,1.0,Commands->Get_ID(enterer));
 		}
@@ -483,13 +498,20 @@
 		float Health = Commands->Get_Health(Commands->Find_Object(number));
 		float Max_Shield_Strength = Commands->Get_Max_Shield_Strength(Commands->Find_Object(number));
 		float Shield_Strength = Commands->Get_Shield_Strength(Commands->Find_Object(number));
+		bool repair = false;
 		if (Health < Max_Health)
 		{
 			Commands->Set_Health(Commands->Find_Object(number),Health + Get_Float_Parameter("Repair_Health"));
+			repair = true;
 		}
 		if (Shield_Strength < Max_Shield_Strength)
 		{
 			Commands->Set_Shield_Strength(Commands->Find_Object(number),Shield_Strength + Get_Float_Parameter("Repair_Health"));
+			repair = true;
+		}
+		if (repair && Commands->Find_Object(number)->As_VehicleGameObj())
+		{
+			Commands->Find_Object(number)->As_VehicleGameObj()->Damage_Meshes_Update(); //repair was done, update damage meshes
 		}
 		Commands->Start_Timer(obj,this,1.0,number);
 	}
@@ -630,7 +652,7 @@
 	{
 		return;
 	}
-	if (Is_Soldier(obj))
+	if (enterer->As_SoldierGameObj())
 	{
 		Commands->Start_Timer(obj,this,1.0,Commands->Get_ID(enterer));
 	}
@@ -703,7 +725,7 @@
 
 void JFW_Disable_Transitions_Zone::Entered(GameObject *obj,GameObject *enterer)
 {
-	if (Is_Vehicle(enterer))
+	if (enterer->As_VehicleGameObj())
 	{
 		Commands->Enable_Vehicle_Transitions(enterer,false);
 	}
@@ -711,7 +733,7 @@
 
 void JFW_Disable_Transitions_Zone::Exited(GameObject *obj,GameObject *exiter)
 {
-	if (Is_Vehicle(exiter))
+	if (exiter->As_VehicleGameObj())
 	{
 		Commands->Enable_Vehicle_Transitions(exiter,true);
 	}
@@ -729,7 +751,7 @@
 	}
 	pos = Commands->Get_Position(enterer);
 	pos.Z += Get_Float_Parameter("ZAmount");
-	angle = Commands->Get_Facing(obj);
+	angle = DEG_TO_RADF(Commands->Get_Facing(obj));
 	pos.X += Get_Float_Parameter("Amount")*(float)cos(angle);
 	pos.Y += Get_Float_Parameter("Amount")*(float)sin(angle);
 	Commands->Set_Position(enterer,pos);
@@ -767,7 +789,7 @@
 
 void JFW_Vechicle_Damage_Zone::Entered(GameObject *obj,GameObject *enterer)
 {
-	if (Is_Vehicle(enterer))
+	if (enterer->As_VehicleGameObj())
 	{
 		int Player_Type = Get_Int_Parameter("Player_Type");
 		if (CheckPlayerType(enterer,Player_Type))
@@ -899,7 +921,7 @@
 	{
 		return;
 	}
-	if (Is_Vehicle(enterer))
+	if (enterer->As_VehicleGameObj())
 	{
 		if (Get_Vehicle_Mode(enterer) == VEHICLE_TYPE_FLYING)
 		{
@@ -922,13 +944,20 @@
 		float Health = Commands->Get_Health(Commands->Find_Object(number));
 		float Max_Shield_Strength = Commands->Get_Max_Shield_Strength(Commands->Find_Object(number));
 		float Shield_Strength = Commands->Get_Shield_Strength(Commands->Find_Object(number));
+		bool repair = false;
 		if (Health < Max_Health)
 		{
 			Commands->Set_Health(Commands->Find_Object(number),Health + Get_Float_Parameter("Repair_Health"));
+			repair = true;
 		}
 		if (Shield_Strength < Max_Shield_Strength)
 		{
 			Commands->Set_Shield_Strength(Commands->Find_Object(number),Shield_Strength + Get_Float_Parameter("Repair_Health"));
+			repair = true;
+		}
+		if (repair && Commands->Find_Object(number)->As_VehicleGameObj())
+		{
+			Commands->Find_Object(number)->As_VehicleGameObj()->Damage_Meshes_Update(); //repair was done, update damage meshes
 		}
 		Commands->Start_Timer(obj,this,1.0,number);
 	}
@@ -941,7 +970,7 @@
 	{
 		return;
 	}
-	if (Is_Vehicle(enterer))
+	if (enterer->As_VehicleGameObj())
 	{
 		if (Get_Vehicle_Mode(enterer) != VEHICLE_TYPE_FLYING)
 		{
@@ -964,13 +993,20 @@
 		float Health = Commands->Get_Health(Commands->Find_Object(number));
 		float Max_Shield_Strength = Commands->Get_Max_Shield_Strength(Commands->Find_Object(number));
 		float Shield_Strength = Commands->Get_Shield_Strength(Commands->Find_Object(number));
+		bool repair = false;
 		if (Health < Max_Health)
 		{
 			Commands->Set_Health(Commands->Find_Object(number),Health + Get_Float_Parameter("Repair_Health"));
+			repair = true;
 		}
 		if (Shield_Strength < Max_Shield_Strength)
 		{
 			Commands->Set_Shield_Strength(Commands->Find_Object(number),Shield_Strength + Get_Float_Parameter("Repair_Health"));
+			repair = true;
+		}
+		if (repair && Commands->Find_Object(number)->As_VehicleGameObj())
+		{
+			Commands->Find_Object(number)->As_VehicleGameObj()->Damage_Meshes_Update(); //repair was done, update damage meshes
 		}
 		Commands->Start_Timer(obj,this,1.0,number);
 	}
@@ -1545,7 +1581,7 @@
 
 void JFW_Heavy_Vehicle_Damage_Zone::Entered(GameObject *obj,GameObject *enterer)
 {
-	if (Is_Vehicle(enterer))
+	if (enterer->As_VehicleGameObj())
 	{
 		int Player_Type = Get_Int_Parameter("Player_Type");
 		if ((CheckPlayerType(enterer,Player_Type)) || (Get_Mass(enterer) < Get_Float_Parameter("Mass")))
@@ -1577,7 +1613,7 @@
 
 void JFW_Light_Vehicle_Damage_Zone::Entered(GameObject *obj,GameObject *enterer)
 {
-	if (Is_Vehicle(enterer))
+	if (enterer->As_VehicleGameObj())
 	{
 		int Player_Type = Get_Int_Parameter("Player_Type");
 		if ((CheckPlayerType(enterer,Player_Type)) || (Get_Mass(enterer) > Get_Float_Parameter("Mass")))
@@ -1877,7 +1913,7 @@
 
 void JFW_Vehicle_Zone_Animation::Entered(GameObject *obj,GameObject *enterer)
 {
-	if (Is_Vehicle(enterer))
+	if (enterer->As_VehicleGameObj())
 	{
 		if (!refcount)
 		{
@@ -1918,7 +1954,7 @@
 
 void JFW_Vehicle_Zone_Animation::Exited(GameObject *obj,GameObject *exiter)
 {
-	if (Is_Vehicle(exiter))
+	if (exiter->As_VehicleGameObj())
 	{
 		refcount--;
 		if (!refcount)
@@ -2093,7 +2129,7 @@
 	{
 		return;
 	}
-	if ((Is_Building_Dead(Find_Com_Center(Commands->Get_Player_Type(enterer))) && (Is_Radar_Enabled(PTTEAM(Commands->Get_Player_Type(enterer))))))
+	if (Find_Com_Center(Commands->Get_Player_Type(enterer)) && (Is_Building_Dead(Find_Com_Center(Commands->Get_Player_Type(enterer))) && (Is_Radar_Enabled(PTTEAM(Commands->Get_Player_Type(enterer))))))
 	{
 		Create_2D_Sound_Team(Get_Parameter("Sound"),Commands->Get_Player_Type(enterer));
 		Enable_Base_Radar(Get_Object_Type(enterer),true);
@@ -2116,7 +2152,7 @@
 	{
 		return;
 	}
-	if ((Is_Building_Dead(Find_Com_Center(Commands->Get_Player_Type(enterer))) && (Is_Radar_Enabled(PTTEAM(Commands->Get_Player_Type(enterer))))))
+	if (Find_Com_Center(Commands->Get_Player_Type(enterer)) && (Is_Building_Dead(Find_Com_Center(Commands->Get_Player_Type(enterer))) && (Is_Radar_Enabled(PTTEAM(Commands->Get_Player_Type(enterer))))))
 	{
 		Create_2D_Sound_Team(Get_Parameter("Sound"),Commands->Get_Player_Type(enterer));
 		Enable_Base_Radar(Get_Object_Type(enterer),true);
@@ -2162,7 +2198,7 @@
 	{
 		return;
 	}
-	if (Is_Vehicle(enterer))
+	if (enterer->As_VehicleGameObj())
 	{
 		Create_2D_Sound_Player(Get_Vehicle_Driver(enterer),Get_Parameter("Sound"));
 		InstallHook("Repair",Get_Vehicle_Driver(enterer));
@@ -2207,6 +2243,10 @@
 				}
 				if (cost_scale > 0)
 				{
+					if (Commands->Find_Object(number)->As_VehicleGameObj())
+					{
+						Commands->Find_Object(number)->As_VehicleGameObj()->Damage_Meshes_Update(); //repair was done, update damage meshes
+					}
 					Commands->Give_Money(Get_Vehicle_Driver(Commands->Find_Object(number)),-cost * cost_scale,false);
 					Commands->Start_Timer(obj,this,1.0,number);
 					return;
@@ -2273,7 +2313,7 @@
 	{
 		return;
 	}
-	if (Is_Vehicle(enterer) && !Is_Script_Attached(enterer,"JFW_Boat"))
+	if (enterer->As_VehicleGameObj() && Get_Vehicle_Mode(enterer) != VEHICLE_TYPE_BOAT && Get_Vehicle_Mode(enterer) != VEHICLE_TYPE_SUB)
 	{
 		Create_2D_Sound_Player(Get_Vehicle_Driver(enterer),Get_Parameter("Sound"));
 		InstallHook("Repair",Get_Vehicle_Driver(enterer));
@@ -2318,6 +2358,10 @@
 				}
 				if (cost_scale > 0)
 				{
+					if (Commands->Find_Object(number)->As_VehicleGameObj())
+					{
+						Commands->Find_Object(number)->As_VehicleGameObj()->Damage_Meshes_Update(); //repair was done, update damage meshes
+					}
 					Commands->Give_Money(Get_Vehicle_Driver(Commands->Find_Object(number)),-cost * cost_scale,false);
 					Commands->Start_Timer(obj,this,1.0,number);
 					return;
@@ -2384,7 +2428,7 @@
 	{
 		return;
 	}
-	if (Is_Vehicle(enterer) && Is_Script_Attached(enterer,"JFW_Boat"))
+	if (enterer->As_VehicleGameObj() && (Get_Vehicle_Mode(enterer) == VEHICLE_TYPE_BOAT || Get_Vehicle_Mode(enterer) == VEHICLE_TYPE_SUB))
 	{
 		Create_2D_Sound_Player(Get_Vehicle_Driver(enterer),Get_Parameter("Sound"));
 		InstallHook("Repair",Get_Vehicle_Driver(enterer));
@@ -2429,6 +2473,10 @@
 				}
 				if (cost_scale > 0)
 				{
+					if (Commands->Find_Object(number)->As_VehicleGameObj())
+					{
+						Commands->Find_Object(number)->As_VehicleGameObj()->Damage_Meshes_Update(); //repair was done, update damage meshes
+					}
 					Commands->Give_Money(Get_Vehicle_Driver(Commands->Find_Object(number)),-cost * cost_scale,false);
 					Commands->Start_Timer(obj,this,1.0,number);
 					return;
@@ -2495,7 +2543,7 @@
 	{
 		return;
 	}
-	if (Is_Vehicle(enterer))
+	if (enterer->As_VehicleGameObj())
 	{
 		Create_2D_Sound_Player(Get_Vehicle_Driver(enterer),Get_Parameter("Sound"));
 		InstallHook("Sell",Get_Vehicle_Driver(enterer));
@@ -2525,7 +2573,7 @@
 		RemoveHook();
 		ID = 0;
 	}
-	if (Is_Vehicle(Commands->Find_Object(ID)))
+	if (Commands->Find_Object(ID)->As_VehicleGameObj())
 	{
 		if (Get_Vehicle_Driver(Commands->Find_Object(ID)))
 		{
@@ -3027,21 +3075,9 @@
 	if (object)
 	{
 		Vector3 v = Get_Vector3_Parameter("Size");
-		object->Get_Bounding_Box().Extent.X = v.X;
-		object->Get_Bounding_Box().Extent.Y = v.Y;
-		object->Get_Bounding_Box().Extent.Z = v.Z;
-		float z = Get_Float_Parameter("ZRotate");
-		float c = cos(z);
-		float s = sin(z);
-		object->Get_Bounding_Box().Basis[0].X = c;
-		object->Get_Bounding_Box().Basis[0].Y = -s;
-		object->Get_Bounding_Box().Basis[0].Z = 0;
-		object->Get_Bounding_Box().Basis[1].X = s;
-		object->Get_Bounding_Box().Basis[1].Y = c;
-		object->Get_Bounding_Box().Basis[1].Z = 0;
-		object->Get_Bounding_Box().Basis[2].X = 0;
-		object->Get_Bounding_Box().Basis[2].Y = 0;
-		object->Get_Bounding_Box().Basis[2].Z = 1;
+		object->Get_Bounding_Box().Extent = v;
+		float z = DEG_TO_RADF(Get_Float_Parameter("ZRotate"));
+		object->Get_Bounding_Box().Basis.Rotate_Z(z);
 	}
 	Destroy_Script();
 }
@@ -3136,11 +3172,11 @@
 		return;
 	}
 	team = Commands->Get_Player_Type(enterer);
-	if (Is_Base_Powered(PTTEAM(team)) && !reset && (!Is_Building_Dead(Find_Building(PTTEAM(team),BuildingConstants::TYPE_POWER_PLANT))))
+	if (Is_Base_Powered(PTTEAM(team)) && !reset && Find_Building_By_Type(PTTEAM(team),BuildingConstants::TYPE_POWER_PLANT) && (!Is_Building_Dead(Find_Building_By_Type(PTTEAM(team),BuildingConstants::TYPE_POWER_PLANT))))
 	{
 		Create_2D_Sound_Team(Get_Parameter("Sound"),team);
 		Power_Base(PTTEAM(team),false);
-		GameObject *o = Find_Building(PTTEAM(team),BuildingConstants::TYPE_COM_CENTER);
+		GameObject *o = Find_Building_By_Type(PTTEAM(team),BuildingConstants::TYPE_COM_CENTER);
 		if (o && !Is_Building_Dead(o))
 		{
 			Enable_Base_Radar(PTTEAM(team),false);
@@ -3151,11 +3187,11 @@
 
 void JFW_Power_Spy_Zone::Timer_Expired(GameObject *obj,int number)
 {
-	if ((number == 1) && (!Is_Building_Dead(Find_Building(PTTEAM(team),BuildingConstants::TYPE_POWER_PLANT))))
+	if ((number == 1) && Find_Building_By_Type(PTTEAM(team),BuildingConstants::TYPE_POWER_PLANT) && (!Is_Building_Dead(Find_Building_By_Type(PTTEAM(team),BuildingConstants::TYPE_POWER_PLANT))))
 	{
 		Create_2D_Sound_Team(Get_Parameter("Sound2"),PTTEAM(team));
 		Power_Base(PTTEAM(team),true);
-		GameObject *o = Find_Building(PTTEAM(team),BuildingConstants::TYPE_COM_CENTER);
+		GameObject *o = Find_Building_By_Type(PTTEAM(team),BuildingConstants::TYPE_COM_CENTER);
 		if (o && !Is_Building_Dead(o))
 		{
 			Enable_Base_Radar(PTTEAM(team),true);
@@ -3210,11 +3246,11 @@
 		return;
 	}
 	team = Commands->Get_Player_Type(enterer);
-	if (Is_Base_Powered(PTTEAM(team)) && !reset && (!Is_Building_Dead(Find_Building(PTTEAM(team),BuildingConstants::TYPE_POWER_PLANT))))
+	if (Is_Base_Powered(PTTEAM(team)) && !reset && Find_Building_By_Type(PTTEAM(team),BuildingConstants::TYPE_POWER_PLANT) && (!Is_Building_Dead(Find_Building_By_Type(PTTEAM(team),BuildingConstants::TYPE_POWER_PLANT))))
 	{
 		Create_2D_Sound_Team(Get_Parameter("Sound"),team);
 		Power_Base(PTTEAM(team),false);
-		GameObject *o = Find_Building(PTTEAM(team),BuildingConstants::TYPE_COM_CENTER);
+		GameObject *o = Find_Building_By_Type(PTTEAM(team),BuildingConstants::TYPE_COM_CENTER);
 		if (o && !Is_Building_Dead(o))
 		{
 			Enable_Base_Radar(PTTEAM(team),false);
@@ -3225,11 +3261,11 @@
 
 void JFW_Power_Spy_Zone_New::Timer_Expired(GameObject *obj,int number)
 {
-	if ((number == 1) && (!Is_Building_Dead(Find_Building(PTTEAM(team),BuildingConstants::TYPE_POWER_PLANT))))
+	if ((number == 1) && Find_Building_By_Type(PTTEAM(team),BuildingConstants::TYPE_POWER_PLANT) && (!Is_Building_Dead(Find_Building_By_Type(PTTEAM(team),BuildingConstants::TYPE_POWER_PLANT))))
 	{
 		Create_2D_Sound_Team(Get_Parameter("Sound2"),PTTEAM(team));
 		Power_Base(PTTEAM(team),true);
-		GameObject *o = Find_Building(PTTEAM(team),BuildingConstants::TYPE_COM_CENTER);
+		GameObject *o = Find_Building_By_Type(PTTEAM(team),BuildingConstants::TYPE_COM_CENTER);
 		if (o && !Is_Building_Dead(o))
 		{
 			Enable_Base_Radar(PTTEAM(team),true);
@@ -3255,23 +3291,23 @@
 	{
 		return;
 	}
-	int team = Commands->Get_Player_Type(enterer);
-	if (!cydisabled && !reset && (!Is_Building_Dead(Find_Building(PTTEAM(team),BuildingConstants::TYPE_CONYARD))))
+	team = Commands->Get_Player_Type(enterer);
+	if (!cydisabled && !reset && Find_Building_By_Type(PTTEAM(team),BuildingConstants::TYPE_CONYARD) && (!Is_Building_Dead(Find_Building_By_Type(PTTEAM(team),BuildingConstants::TYPE_CONYARD))))
 	{
 		Create_2D_Sound_Team(Get_Parameter("Sound"),team);
 		cydisabled = true;
-		Commands->Send_Custom_Event(obj,Find_Building(PTTEAM(team),BuildingConstants::TYPE_CONYARD),3000,320023,0);
+		Commands->Send_Custom_Event(obj,Find_Building_By_Type(PTTEAM(team),BuildingConstants::TYPE_CONYARD),3000,320023,0);
 		Commands->Start_Timer(obj,this,Get_Float_Parameter("Power_Time"),1);
 	}
 }
 
 void JFW_Conyard_Spy_Zone::Timer_Expired(GameObject *obj,int number)
 {
-	if ((number == 1) && (!Is_Building_Dead(Find_Building(PTTEAM(team),BuildingConstants::TYPE_CONYARD))))
+	if ((number == 1) && Find_Building_By_Type(PTTEAM(team),BuildingConstants::TYPE_CONYARD) && (!Is_Building_Dead(Find_Building_By_Type(PTTEAM(team),BuildingConstants::TYPE_CONYARD))))
 	{
 		Create_2D_Sound_Team(Get_Parameter("Sound2"),PTTEAM(team));
 		cydisabled = false;
-		Commands->Send_Custom_Event(obj,Find_Building(PTTEAM(team),BuildingConstants::TYPE_CONYARD),3000,230032,0);
+		Commands->Send_Custom_Event(obj,Find_Building_By_Type(PTTEAM(team),BuildingConstants::TYPE_CONYARD),3000,230032,0);
 		reset = true;
 		Commands->Start_Timer(obj,this,Get_Float_Parameter("Reset_Time"),2);
 	}
@@ -3293,8 +3329,8 @@
 	{
 		return;
 	}
-	int team = Commands->Get_Player_Type(enterer);
-	if (!cydisabled && !reset && (!Is_Building_Dead(Find_Construction_Yard(PTTEAM(team)))))
+	team = Commands->Get_Player_Type(enterer);
+	if (!cydisabled && !reset && Find_Construction_Yard(PTTEAM(team)) && (!Is_Building_Dead(Find_Construction_Yard(PTTEAM(team)))))
 	{
 		Create_2D_Sound_Team(Get_Parameter("Sound"),team);
 		cydisabled = true;
@@ -3306,7 +3342,7 @@
 
 void JFW_Conyard_Spy_Zone_2::Timer_Expired(GameObject *obj,int number)
 {
-	if ((number == 1) && (!Is_Building_Dead(Find_Building(PTTEAM(team),BuildingConstants::TYPE_CONYARD))))
+	if ((number == 1) && Find_Construction_Yard(PTTEAM(team)) && (!Is_Building_Dead(Find_Construction_Yard(PTTEAM(team)))))
 	{
 		Create_2D_Sound_Team(Get_Parameter("Sound2"),PTTEAM(team));
 		cydisabled = false;
@@ -3333,8 +3369,8 @@
 	{
 		return;
 	}
-	int team = Commands->Get_Player_Type(enterer);
-	if (!cydisabled && !reset && (!Is_Building_Dead(Find_Construction_Yard(PTTEAM(team)))))
+	team = Commands->Get_Player_Type(enterer);
+	if (!cydisabled && !reset && Find_Construction_Yard(PTTEAM(team)) && (!Is_Building_Dead(Find_Construction_Yard(PTTEAM(team)))))
 	{
 		Create_2D_Sound_Team(Get_Parameter("Sound"),team);
 		cydisabled = true;
@@ -3346,7 +3382,7 @@
 
 void JFW_Conyard_Spy_Zone_2_New::Timer_Expired(GameObject *obj,int number)
 {
-	if ((number == 1) && (!Is_Building_Dead(Find_Building(PTTEAM(team),BuildingConstants::TYPE_CONYARD))))
+	if ((number == 1) && Find_Construction_Yard(PTTEAM(team)) && (!Is_Building_Dead(Find_Construction_Yard(PTTEAM(team)))))
 	{
 		Create_2D_Sound_Team(Get_Parameter("Sound2"),PTTEAM(team));
 		cydisabled = false;
@@ -3361,6 +3397,15 @@
 	}
 }
 
+void JFW_Destroy_Vehicle_Zone::Entered(GameObject *obj,GameObject *enterer)
+{
+	if (enterer->As_VehicleGameObj())
+	{
+		Attach_Script_Occupants(enterer,"RA_DriverDeath", "0");
+	}
+	Commands->Apply_Damage(enterer,99999,"Death",0);
+}
+
 ScriptRegistrant<JFW_Look_At_Location_Entry> JFW_Look_At_Location_Entry("JFW_Look_At_Location_Entry","Player_Type:int,Location:vector3");
 ScriptRegistrant<JFW_Look_At_Object_Entry> JFW_Look_At_Object_Entry("JFW_Look_At_Object_Entry","Player_Type:int,ObjectID:int");
 ScriptRegistrant<JFW_Zone_PCT> JFW_Zone_PCT_Registrant("JFW_Zone_PCT","Player_Type:int");
@@ -3452,3 +3497,4 @@
 ScriptRegistrant<JFW_Custom_Spawn_Zone> JFW_Custom_Spawn_Zone_Registrant("JFW_Custom_Spawn_Zone","Position:vector3,Size:vector3,ZRotate:float,SpawnCustom:int,DestroyCustom:int,Preset:string");
 ScriptRegistrant<JFW_Spawn_Zone_Created> JFW_Spawn_Zone_Created_Registrant("JFW_Spawn_Zone_Created","Offset:vector3,Size:vector3,ZRotate:float,Preset:string");
 ScriptRegistrant<JFW_Boat> JFW_Boat_Registrant("JFW_Boat","");
+ScriptRegistrant<JFW_Destroy_Vehicle_Zone> JFW_Destroy_Vehicle_Zone_Registrant("JFW_Destroy_Vehicle_Zone","");
diff -uwr sourceold/scripts/jfwzone.h source/scripts/jfwzone.h
--- sourceold/scripts/jfwzone.h	2012-02-13 18:44:52.651765600 +0800
+++ source/scripts/jfwzone.h	2012-04-15 11:56:05.470093800 +0800
@@ -542,3 +542,7 @@
 
 class JFW_Boat : public ScriptImpClass {
 };
+
+class JFW_Destroy_Vehicle_Zone : public ScriptImpClass {
+	void Entered(GameObject *obj,GameObject *enterer);
+};
diff -uwr sourceold/scripts/jmgrp2.h source/scripts/jmgrp2.h
--- sourceold/scripts/jmgrp2.h	2011-10-14 22:27:32.057617100 +0800
+++ source/scripts/jmgrp2.h	2012-05-23 10:34:38.099609300 +0800
@@ -587,10 +587,18 @@
 	void Timer_Expired(GameObject *obj,int number);
 	void Damaged(GameObject *obj,GameObject *damager,float damage);
 	void Killed(GameObject *obj, GameObject *damager);
+public:
+	JMG_Prostitute_Script()
+	{
+		name = 0;
+	}
 	~JMG_Prostitute_Script()
 	{
+		if (name)
+		{
 		delete[] name;
 	}
+	}
 };
 
 class JMG_Keyboard_Input_Custom : public JFW_Key_Hook_Base {
diff -uwr sourceold/scripts/kak.cpp source/scripts/kak.cpp
--- sourceold/scripts/kak.cpp	2011-10-11 23:05:59.489257800 +0800
+++ source/scripts/kak.cpp	2012-04-24 21:25:35.342773400 +0800
@@ -471,7 +471,6 @@
 		if (HarvyID)
 		{
 			Commands->Apply_Damage(Commands->Find_Object(HarvyID),99999,"Explosive",0);
-			if (!Commands->Get_ID(Commands->Find_Object(HarvyID))) Commands->Destroy_Object(Commands->Find_Object(HarvyID));
 			Commands->Destroy_Object(obj);
 		}
 	}
diff -uwr sourceold/scripts/mdb.cpp source/scripts/mdb.cpp
--- sourceold/scripts/mdb.cpp	2012-02-13 19:12:33.842195300 +0800
+++ source/scripts/mdb.cpp	2012-04-24 13:23:00.471679600 +0800
@@ -205,7 +205,7 @@
 			{
 				if (Verify_Preset_Limit(2, Get_Int_Parameter("Limit"), Definitions, 4))
 				{
-					if (ExpVehFac[team] && ExpVehFac[team]->Loaded && Is_Vehicle(obj))
+					if (ExpVehFac[team] && ExpVehFac[team]->Loaded && obj->As_VehicleGameObj())
 					{
 						UnitInfo* info = ExpVehFac[team]->Get_Unit_Info(def_id);
 						info->DMode = (info->DMode == DISABLED_EVF) ? DISABLED_BOTH : DISABLED_UNIT;
@@ -258,7 +258,7 @@
 			
 			bool enable_preset = true;
 			int evf_team = !Team;
-			if (ExpVehFac[evf_team] && ExpVehFac[evf_team]->Loaded && Is_Vehicle(obj))
+			if (ExpVehFac[evf_team] && ExpVehFac[evf_team]->Loaded && obj->As_VehicleGameObj())
 			{
 				UnitInfo* info = ExpVehFac[evf_team]->Get_Unit_Info(Commands->Get_Preset_ID(obj));
 				if (info)
